function vowel_emotion_triangle
%--------------------------------------------------------------------------
% Copyright(c) Zbancioc Marius-Dan, 2014, zmarius@etti.tuiasi.ro
% 1)Institute of Computer Science, Roumanian Academy, Iasi Branch, 
% 2)Technical University "Gheorghe Asachi" of Iasi, Romania
%--------------------------------------------------------------------------
% References:
%- M. Zbancioc, M. Feraru, The Analysis of the FCM and WKNN Algorithms Performance for the Emotional Corpus SROL, Advances in Electrical and Computer Engineering, Vol. 12, Issue 3, 2012, pp. 33  38, ISSN: 1582-7445, e-ISSN: 1844-7600, Digital Object Identifier: 10.4316/AECE.2012.03005
%- M. Feraru, M. Zbancioc, Speech Emotion Recognition for SROL Database using Weighted KNN algorithm, International Conference on Electronics, Computers and Artificial Intelligence (ECAI2013), June 27-29, 2013, Pitesti, Romania, ISBN: 978-1-4673-4935-2, Digital Object Identifier: 10.1109/ECAI.2013.6636189 2013 IEEE
%- M. Zbancioc, M. Feraru, A Study about MFCC Relevance in Emotion Classification for SROL Database, Proceedings of 4th International Symposium on Electrical and Electronics Engineering, ISEEE 2013, October, 11-13, 2013, Gala?i, Romnia, ISBN 978-1-4799-2441-7, IEEE Catalog Number CFP1393K-USB.
%- M. Zbancioc, M. Feraru, Using the Lyapunov Exponent from Cepstral Coefficients for Automatic Emotion Recognition, Proc of 8th IEEE International Conference on Electrical and Power Engineering  EPE 2014, 16-17 Oct., Ia?i, Romnia, ISSN: 978-1-4799-5848-1.
%- M. Feraru, M. Zbancioc, Emotion Recognition in Romanian Language using LPC Features, The 4th IEEE International Conference on E-Health and Bioengineering - EHB 2013, November 21-23, 2013, Ia?i, Romania, ISBN: 978-1-4799-2373-1/13/$31.00 2013 IEEE
%--------------------------------------------------------------------------

[DB DB_all] = construct_DB_all_emotions;

plot_toate_vocalele = 1;
plot_triunghi_vocale = 0;
n_intervale = 10; overwrite_hist2D=0; calcul_hist_2D = 0;
calcul_rap_Fk_F0 = 0;
plot_hist_2D = 0;
plot_distributii_vocale = 0;

idx_F1 = 6; idx_F2 = 9; %use only mean values of F1 and F2 (mean_F1 and mean_F2)
%idx_F1 = 6; idx_F2 = 11; %use median_F2 and mean_F1 
%idx_F1 = 8; idx_F2 = 11; %use median of F1 and F2

marker = 'ox+*sdv';
color = 'bgrcmyk';
%rgb=[0 0 1; 0 1 0; 1 0 0; 1 1 0; 1 0 1; 0 1 1; 0 0 0];
rgb=[0 0 1; 1 .5 0; 1 0 0; 0 .5 0; .5 0 .5; .5 .5 .5; 0 0 0];
%--------------------------------------------------------------------------
if plot_toate_vocalele,
    figure(1); hold on; 
        for i=1:8, for k=1:length(DB{i}), 
            plot(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, '.w'); text(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, DB{i}{k}{1},'color', rgb(k,:)); %color(k));
            %plot(log(DB{i}{k}{idx_F1}), log(DB{i}{k}{idx_F2}), '.w'); text(log(DB{i}{k}{idx_F1}), log(DB{i}{k}{idx_F2}), DB{i}{k}{1},'color', rgb(k,:)); %color(k));
        end; end
        for i=1:8, for k=1:length(DB{i}); 
            plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',20, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
            %plot(log(mean_NaN(DB{i}{k}{idx_F1})), log(mean_NaN(DB{i}{k}{idx_F2})), 'o', 'MarkerSize',20, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
        end; end
        hold off; axis tight; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - all speakers');

    figure(2); hold on; 
        for k=1:length(DB_all), 
            plot(DB_all{k}{idx_F1}, DB_all{k}{idx_F2}, '.w'); text(DB_all{k}{idx_F1}, DB_all{k}{idx_F2}, DB_all{k}{1},'color', rgb(k,:)); %color(k));
        end
        for k=1:length(DB_all); 
            plot(mean_NaN(DB_all{k}{idx_F1}), mean_NaN(DB_all{k}{idx_F2}), 'o', 'MarkerSize',20, 'LineWidth',4, 'color', rgb(k,:)); %color(k));
        end
        hold off; axis tight; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - all speakers');
end
%--------------------------------------------------------------------------
%------------------     Vowel traingle (F1,F2)     ------------------
%--------------------------------------------------------------------------
if plot_triunghi_vocale,
    legend_text = {'neutral','fury','sadness','joy'}; l=zeros(1,4);
    linestyle = {'-','-',':','-.'}; %linestyle = {'-','--',':','-.'};
    linewidth = [1.5,0.5,0.5,0.5];
    figure(plot_toate_vocalele*2+1); hold on; 
            for i=1:2:8 %female person selection
                px=[];py=[];
                for k=1:length(DB{i}),
                    plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); 
                    text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), DB{i}{k}{1},'FontSize',18,'color', rgb(i,:)); %color(k));
                    if length(find('aiu'==DB{i}{k}{1}(1))) & DB{i}{k}{1}(2)==0, px=[px mean_NaN(DB{i}{k}{idx_F1})]; py=[py mean_NaN(DB{i}{k}{idx_F2})]; end
                    %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',10, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
                end;
                px = [px px(1)]; py = [py py(1)]; l((i+1)/2) = line(px,py,'color',rgb(i,:),'LineStyle',linestyle{(i+1)/2},'LineWidth',linewidth((i+1)/2));
            end
            legend(l, legend_text);
            hold off; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - female persons'); 
            axis tight; a=axis; axis([a(1)*0.9 a(2)*1.05 a(3)*0.9 a(4)*1.05]);

    figure(plot_toate_vocalele*2+2); hold on; 
            for i=2:2:8 %male person selection
                px=[];py=[];
                for k=1:length(DB{i}), 
                    plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); 
                    text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), DB{i}{k}{1},'FontSize',18,'color', rgb(i-1,:)); %color(k));
                    if length(find('aiu'==DB{i}{k}{1}(1))) & DB{i}{k}{1}(2)==0, px=[px mean_NaN(DB{i}{k}{idx_F1})]; py=[py mean_NaN(DB{i}{k}{idx_F2})]; end
                    %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',10, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
                end;
                px = [px px(1)]; py = [py py(1)]; l(i/2) = line(px,py,'color',rgb(i-1,:),'LineStyle',linestyle{i/2},'LineWidth',linewidth(i/2));
            end
            legend(l, legend_text);
            hold off; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - male persons');
            axis tight; a=axis; axis([a(1)*0.9 a(2)*1.05 a(3)*0.9 a(4)*1.05]);
            
    figure(plot_toate_vocalele*2+3); hold on; 
            px=[];py=[];
            for k=1:length(DB_all), 
                plot(mean_NaN(DB_all{k}{idx_F1}), mean_NaN(DB_all{k}{idx_F2}), '.w'); 
                text(mean_NaN(DB_all{k}{idx_F1}), mean_NaN(DB_all{k}{idx_F2}), DB_all{k}{1},'FontSize',18); %color(k));
                if length(find('aiu'==DB_all{k}{1}(1))) & DB_all{k}{1}(2)==0, px=[px mean_NaN(DB_all{k}{idx_F1})]; py=[py mean_NaN(DB_all{k}{idx_F2})]; end
                %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',10, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
            end;
            px = [px px(1)]; py = [py py(1)]; line(px,py);
            hold off; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle');
            axis tight; a=axis; axis([a(1)*0.9 a(2)*1.05 a(3)*0.9 a(4)*1.05]);

    figure(plot_toate_vocalele*2+4); hold on; 
            for i=1:2:8
                for k=1:length(DB{i}),
                    plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); 
                    text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), DB{i}{k}{1},'FontSize',18,'color', rgb(i,:)); %color(k));
                     %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',10, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
                end;
            end
            %vowel={'a','i','u'};
            %vowel={'i','e','a','a+','o','u','a-'};
            vowel={'i','e','a','a+','u','o','a-'};
            for i=1:2:8
                px=[];py=[];
                for j=1:length(vowel),
                    for k=1:length(DB{i}),
                        cur_vowel=DB{i}{k}{1}(find(DB{i}{k}{1}));
                    if strcmp(cur_vowel, vowel{j}), px=[px mean_NaN(DB{i}{k}{idx_F1})]; py=[py mean_NaN(DB{i}{k}{idx_F2})]; end
                end,end
                px = [px px(1)]; py = [py py(1)]; l((i+1)/2) = line(px,py,'color',rgb(i,:),'LineStyle',linestyle{(i+1)/2},'LineWidth',linewidth((i+1)/2));
            end
            legend(l, legend_text);
            hold off; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - female persons'); 
            axis tight; a=axis; axis([a(1)*0.9 a(2)*1.05 a(3)*0.9 a(4)*1.05]);

    figure(plot_toate_vocalele*2+5); hold on; 
            for i=2:2:8
                for k=1:length(DB{i}),
                    plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); 
                    text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), DB{i}{k}{1},'FontSize',18,'color', rgb(i-1,:)); %color(k));
                     %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',10, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
                end;
            end
            %vowel={'a','i','u'};
            vowel={'i','e','a+','a','o','u','a-'};
            for i=2:2:8
                px=[];py=[];
                for j=1:length(vowel),
                    for k=1:length(DB{i}),
                        cur_vowel=DB{i}{k}{1}(find(DB{i}{k}{1}));
                    if strcmp(cur_vowel, vowel{j}), px=[px mean_NaN(DB{i}{k}{idx_F1})]; py=[py mean_NaN(DB{i}{k}{idx_F2})]; end
                end,end
                px = [px px(1)]; py = [py py(1)]; l(i/2) = line(px,py,'color',rgb(i-1,:),'LineStyle',linestyle{i/2},'LineWidth',linewidth(i/2));
            end
            legend(l, legend_text);
            hold off; xlabel('F1'); ylabel('F2'); title('Vowel formant triangle - all emotion - male persons');
            axis tight; a=axis; axis([a(1)*0.9 a(2)*1.05 a(3)*0.9 a(4)*1.05]);
    %----------------------------------------------------
    %compute the areas of the vowel triangles (accoding to the emotion)
    mean_F1value = zeros(8,7); mean_F2value = zeros(8,7);
    for i=1:8
        for k=1:length(DB{i}), 
            mean_F1value(i,k) = mean_NaN(DB{i}{k}{idx_F1});
            mean_F2value(i,k) = mean_NaN(DB{i}{k}{idx_F2}); 
        end;
        selection = [2,3,5];
        disp(sprintf('%3s\t%.1f\t%.1f\t',emotion_ID(i,:), arie_triunghi(mean_F1value(i,selection), mean_F2value(i,selection))));
    end
    %----------------------------------------------------
    %compute areas of vowels poligons (according to the emotion)
    for i=1:8
        for k=1:length(DB{i}), 
            mean_F1value(i,k) = mean_NaN(DB{i}{k}{idx_F1});
            mean_F2value(i,k) = mean_NaN(DB{i}{k}{idx_F2}); 
        end;
        if mod(i,2)==1, selection = [2 6 1; 1 6 4; 4 5 6; 3 4 5; 3 5 7];
        else            selection = [2 6 1; 1 6 4; 4 5 6; 7 4 3; 4 5 7];
        end
        poligon=0;
        for k = 1:size(selection,1)
            poligon = poligon + arie_triunghi(mean_F1value(i,selection(k,:)), mean_F2value(i,selection(k,:)));
        end
        disp(sprintf('%3s\t%.1f\t%.1f\t',emotion_ID(i,:), poligon));
    end
end
%--------------------------------------------------------------------------
%------------------      Bidimensional histogram       --------------------
%--------------------------------------------------------------------------
if calcul_hist_2D
    % compute matrix hist2D.mat for all vowels and amotional states
    minF1=min(DB_all{1}{idx_F1}); minF2=min(DB_all{1}{idx_F2});
    maxF1=max(DB_all{1}{idx_F1}); maxF2=max(DB_all{1}{idx_F2});
    for i=2:length(DB_all)
        minF1_crt=min(DB_all{i}{idx_F1}); minF2_crt=min(DB_all{i}{idx_F2});
        maxF1_crt=max(DB_all{i}{idx_F1}); maxF2_crt=max(DB_all{i}{idx_F2});
        if minF1>minF1_crt, minF1=minF1_crt; end
        if minF2>minF2_crt, minF2=minF2_crt; end
        if maxF1<maxF1_crt, maxF1=maxF1_crt; end
        if maxF2<maxF2_crt, maxF2=maxF2_crt; end
    end
%    n_intervale = 10;
    deltaF1=(maxF1-minF1)/n_intervale;
    deltaF2=(maxF2-minF2)/n_intervale;

    fname = sprintf('hist2D_%d.mat', n_intervale);
    % Matrix histogram 2D for each state, type speaker and phonem
    if (exist(fname,'file')==2) & overwrite_hist2D==0,
        load(fname); %load hist2D;
    else    
        h=zeros(4,2,7,n_intervale,n_intervale);
        for j=1:length(DB)   %all 4 emotional states (male and female) JF,JM,FF,FM,SF,SM,NF,NM
            for k=1:length(DB{1}) % all 7 vowels={'e','i','a','a+','u','a-','o'};
                tip_sex=mod(j,2); if (tip_sex==0), tip_sex=2; end
                tip_emotie=round(j/2);
                for i=1:DB{j}{k}{2} % occurences of current phonem
                    if isnan( DB{j}{k}{idx_F1}(i) ), continue; end
                    F1_crt = ceil((DB{j}{k}{idx_F1}(i)-minF1)/deltaF1);
                    if F1_crt==0, F1_crt=1; end
                    F2_crt = ceil((DB{j}{k}{idx_F2}(i)-minF2)/deltaF2);
                    if F2_crt==0, F2_crt=1; end
                    h(tip_emotie,tip_sex,k,F1_crt,F2_crt)=h(tip_emotie,tip_sex,k,F1_crt,F2_crt)+1;
                end
            end
        end
        save(fname,'h'); %save hist2D h
    end
    
    disp('Numar de aparitii fonem pentru fiecare stare emotionala (vocala, emotie, nr_fisiere, numar_aparitii)');
    for k=1:length(DB{1}),
        i=7;
        s=sprintf('%s:\t%s %2d %4d/%4d |', DB{i}{k}{1}, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i-6; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i+4; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i-2; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        disp(s);
    end
    disp('Numar de aparitii fonem pentru fiecare stare emotionala (vocala, emotie, nr_fisiere, numar_aparitii)');
    for k=1:length(DB{1}),
        i=8;
        s=sprintf('%s:\t%s %2d %4d/%4d |', DB{i}{k}{1}, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i-6; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i+4; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        i=i-2; s=sprintf('%s\t%s %2d %4d/%4d |', s, emotion_ID(i,:), length(DB{i}{k}{end}), sum(~isnan(DB{i}{k}{idx_F1})), DB{i}{k}{2});
        disp(s);
    end   
end
if plot_hist_2D
    % Plot of bi-dimensional histogram for a single vowel and all the emotional states
    h_all = zeros(7,n_intervale,n_intervale);
    for k=1:length(DB_all)
        %DB_all{k}{3}=sort(DB_all{k}{3});
        for i=1:DB_all{k}{2}
            if isnan( DB_all{k}{idx_F1}(i) ), continue; end
            F1_crt = ceil((DB_all{k}{idx_F1}(i)-minF1)/deltaF1);
            if F1_crt==0, F1_crt=1; end
            F2_crt = ceil((DB_all{k}{idx_F2}(i)-minF2)/deltaF2);
            if F2_crt==0, F2_crt=1; end
            h_all(k,F1_crt,F2_crt)=h_all(k,F1_crt,F2_crt)+1;
        end
    end
    m =zeros(n_intervale,n_intervale);
    vowel=1;    %vowel id
    figure(plot_toate_vocalele*2+plot_triunghi_vocale*5+1); 
            m(:,:)= h_all(vowel,:,:); surfl([minF1:deltaF1:maxF1-1],[minF2:deltaF2:maxF2-1],m); colormap(gray); axis tight;
            xlabel('F1'); ylabel('F2'); title(['Bi-dimensional histogram for vowel "', DB_all{vowel}{1}(find(DB_all{vowel}{1})), '" - all emotional states']);

    % Plot of bi-dimensional histogram for a single vowel and a specified emotional states
    %j=1;
    for j=1:8
    he_all = zeros(7,n_intervale,n_intervale);
    for k=1:length(DB_all)
        %DB_all{k}{3}=sort(DB_all{k}{3});
        for i=1:DB{j}{k}{2}
             if isnan( DB{j}{k}{idx_F1}(i) ), continue; end
            F1_crt = ceil((DB{j}{k}{idx_F1}(i)-minF1)/deltaF1);
            if F1_crt==0, F1_crt=1; end
            F2_crt = ceil((DB{j}{k}{idx_F2}(i)-minF2)/deltaF2);
            if F2_crt==0, F2_crt=1; end
            he_all(k,F1_crt,F2_crt)=he_all(k,F1_crt,F2_crt)+1;
        end
    end
    m =zeros(n_intervale,n_intervale);
    %vowel=1;
    for vowel=1:7
    figure(plot_toate_vocalele*2+plot_triunghi_vocale*5+2); 
            m(:,:)= he_all(vowel,:,:); surfl([minF2:deltaF2:maxF2-1],[minF1:deltaF1:maxF1-1],m); colormap(gray); axis tight;
            xlabel('F2'); ylabel('F1'); title(['Bi-dimensional histogram for vowel "', DB_all{vowel}{1}(find(DB_all{vowel}{1})), '" - ' emotion_ID(j,:)]);
    saveas(gcf,['hist2_vowel_' DB_all{vowel}{1}(find(DB_all{vowel}{1})) '_' emotion_ID(j,:) '.fig']);
    end;end
    %figure(6); hold on; for k=1:7, m(:,:)= h(k,:,:);
    %mesh([minF1:deltaF1:maxF1-1],[minF2:deltaF2:maxF2-1],m); end; hold off;
end
%--------------------------------------------------------------------------
if calcul_rap_Fk_F0==1,
    R=zeros(8,7,4);     %F1/F0 F2/F0 F3/F0 F4/F0
    for i=1:length(DB)   %cele 4 stari emotionale (masculin si feminin) JF,JM,FF,FM,SF,SM,NF,NM
        for k=1:length(DB{1}) % cele 7 foneme (vocale a, e, i, o, u, a+, a-)
            R(i,k,1)=mean_NaN(DB{i}{k}{idx_F1})/mean_NaN(DB{i}{k}{3});
            R(i,k,2)=mean_NaN(DB{i}{k}{idx_F2})/mean_NaN(DB{i}{k}{3});
            R(i,k,3)=mean_NaN(DB{i}{k}{idx_F2})/mean_NaN(DB{i}{k}{3});
            R(i,k,4)=mean_NaN(DB{i}{k}{12})/mean_NaN(DB{i}{k}{3});
            disp(sprintf('%s\t%.1f\t%.1f\t%.1f\t%.1f',emotion_ID(i,:),R(i,k,1),R(i,k,2),R(i,k,3),R(i,k,4)));
        end
    end
end
%--------------------------------------------------------------------------
if plot_distributii_vocale,
    rgb=[0 0 1; 1 .5 0; 1 0 0; 0 .5 0; 1 0 .75; .5 .5 .5; 0 0 0];
    legend_text = {'neutral','fury','sadness','joy'}; l=zeros(1,4);
    linestyle = {'-',':','-','-.'}; %linestyle = {'-','--',':','-.'};
    linewidth = [1.5,0.5,0.5,0.5];
    figure(10); hold on;
    for i=1:2:8
        for k=1:length(DB{i}),
            p = elipse(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2});
            l((i+1)/2) = line(p(:,1),p(:,2),'color',rgb(i,:),'LineStyle',linestyle{(i+1)/2},'LineWidth',linewidth((i+1)/2));
        end
        
%         for k=1:length(DB{i}), 
%             plot(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, '.w'); text(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, DB{i}{k}{1},'color', rgb(i,:)); %color(k));
%         end
        for k=1:length(DB{i}); 
            %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',20, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
            plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}),DB{i}{k}{1},'FontSize',18, 'color', rgb(i,:)); %color(k));
        end
    end
    legend(l, legend_text);
    hold off; xlabel('F1'); ylabel('F2'); title('Multivariate distribution function - all emotion - female persons');
    
    figure(11); hold on;
    for i=2:2:8
        for k=1:length(DB{i}),
            p = elipse(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2});
            l(i/2) = line(p(:,1),p(:,2),'color',rgb(i-1,:),'LineStyle',linestyle{i/2},'LineWidth',linewidth(i/2));
        end
        
%         for k=1:length(DB{i}), 
%             plot(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, '.w'); text(DB{i}{k}{idx_F1}, DB{i}{k}{idx_F2}, DB{i}{k}{1},'color', rgb(i,:)); %color(k));
%         end
        for k=1:length(DB{i}); 
            %plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), 'o', 'MarkerSize',20, 'LineWidth',2, 'color', rgb(k,:)); %color(k));
            plot(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}), '.w'); text(mean_NaN(DB{i}{k}{idx_F1}), mean_NaN(DB{i}{k}{idx_F2}),DB{i}{k}{1},'FontSize',18, 'color', rgb(i-1,:)); %color(k));
        end
    end
    legend(l, legend_text);
    hold off; xlabel('F1'); ylabel('F2'); title('Multivariate distribution function - all emotions - male persons');
    
    figure(7); hold on;
    k=7;
    plot(DB_all{k}{idx_F1}, DB_all{k}{idx_F2}, '.w'); text(DB_all{k}{idx_F1}, DB_all{k}{idx_F2}, DB_all{k}{1}); %color(k));
    for sigma=0.5: 0.5 : 3
        p = elipse(DB_all{k}{idx_F1}, DB_all{k}{idx_F2},sigma);
        line(p(:,1),p(:,2),'LineWidth',1.5); title(['Vowel ' DB_all{k}{1}]);
    end
end

mean_F1value = zeros(1,7); mean_F2value = zeros(1,7);
for k=1:length(DB_all), 
    mean_F1value(k) = mean_NaN(DB_all{k}{idx_F1});
    mean_F2value(k) = mean_NaN(DB_all{k}{idx_F2});
    disp(sprintf('%3s\t%.1f\t%.1f',DB_all{k}{1}, mean_F1value(k), mean_F2value(k)));
end

for i=1:8
    for j=1:7
        disp(DB{i}{j}{1});
    end
    disp('-------');
end

%--------------------------------------------------------------------------
function arie = arie_triunghi(x, y)
a=sqrt((x(1)-x(2))^2 + (y(1)-y(2))^2);
b=sqrt((x(2)-x(3))^2 + (y(2)-y(3))^2);
c=sqrt((x(3)-x(1))^2 + (y(3)-y(1))^2);
p=(a+b+c)/2;

arie = sqrt(p*(p-a)*(p-b)*(p-c));
%--------------------------------------------------------------------------
function arie = arie_triunghi_v2(x, y)
%Both function compute the area of a triangle (same results)
a2=((x(1)-x(2))^2 + (y(1)-y(2))^2);
b2=((x(2)-x(3))^2 + (y(2)-y(3))^2);
c2=((x(3)-x(1))^2 + (y(3)-y(1))^2);

arie = 1/4*sqrt(4*a2*b2-(a2+b2-c2)^2);
%--------------------------------------------------------------------------
function mv = mean_NaN(v)
mv = mean(v(find(~isnan(v))));